package com.bergerkiller.bukkit.nolaggchunks;

import java.util.HashSet;

import net.minecraft.server.Packet;
import net.minecraft.server.Packet29DestroyEntity;

import org.bukkit.entity.Player;
import org.getspout.spoutapi.packet.listener.PacketListener;
import org.getspout.spoutapi.packet.standard.MCPacket;

public class NLPacketListener implements PacketListener {
	
	private static HashSet<Packet> ignoreList = new HashSet<Packet>();
	public static void ignore(Packet p) {
		synchronized (ignoreList) {
			ignoreList.add(p);
		}
	}
	
	@SuppressWarnings("deprecation")
	public boolean checkPacket(Player player, MCPacket mcpacket) {
		PlayerChunkBuffer buffer = PlayerChunkLoader.getBuffer(player);
		if (buffer == null) return true;
		return checkPacket(buffer, mcpacket.getId(), (Packet) mcpacket.getPacket());
	}
		
	public boolean checkPacket(PlayerChunkBuffer buffer, int id, Packet packet) {
		if (packet instanceof Packet29DestroyEntity) {
			return !buffer.removeEntitySpawn(((Packet29DestroyEntity) packet).a);
		} else {
			synchronized (ignoreList) {
				if (ignoreList.remove(packet)) {
					return true;
				}
			}
			if (buffer.isDownloaded()) {
				return buffer.queue(packet);
			} else {
				return buffer.handleChunkDownload(packet);
			}
		}
	}


}
